package com.fizz.business.constants.enums;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * websocket type
 *
 * @author chenhao
 * @date 2023/04/24
 */
@Getter
@AllArgsConstructor
public enum MqOperateEnum {
    ADD, UPDATE, DELETE;

    private static final Map<String, MqOperateEnum> MAP = new HashMap<>(8);

    static {
        for (MqOperateEnum e : MqOperateEnum.values()) {
            MAP.put(e.getValue(), e);
        }
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static MqOperateEnum getByValue(String value) {
        return MAP.get(value);
    }

    @JsonValue
    public String getValue() {
        return this.name();
    }
}
